Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 1364)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 1365)
@@ -20,6 +20,8 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+! Reset sums_ls_l to zero at each timestep
+! +sums_ls_l
+! Calculation of reference state (previously in subroutine calc_mean_profile)
+
 ! Former revisions:
 ! -----------------
@@ -126,8 +128,8 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  diss, e_p, nr_p, prho, pt, pt_p, ql, ql_c, ql_v, ql_vp, qr_p,   &
-               q_p, rho, sa_p, tend, u, u_p, v, vpt, v_p, w_p
-
-    USE buoyancy_mod,                                                          &
+        ONLY:  diss, e_p, nr_p, prho, pt, pt_p, q, ql, ql_c, ql_v, ql_vp, qr_p,&
+               q_p, ref_state, rho, sa_p, tend, u, u_p, v, vpt, v_p, w_p
+
+    USE calc_mean_profile_mod,                                                 &
         ONLY:  calc_mean_profile
 
@@ -149,6 +151,6 @@
                intermediate_timestep_count_max, large_scale_forcing,           &
                loop_optimization, lsf_surf, lsf_vert, masks, mid,              &
-               netcdf_data_format, neutral, nr_timesteps_this_run, ocean,      &
-               on_device, passive_scalar, prandtl_layer, precipitation,        &
+               netcdf_data_format, neutral, nr_timesteps_this_run, nudging,    &
+               ocean, on_device, passive_scalar, prandtl_layer, precipitation, &
                prho_reference, pt_reference, pt_slope_offset, random_heatflux, &
                run_coupled, simulated_time, simulated_time_chr,                &
@@ -181,4 +183,7 @@
         ONLY:  ls_forcing_surf, ls_forcing_vert
 
+    USE nudge_mod,                                                             &
+        ONLY:  calc_tnudge
+
     USE particle_attributes,                                                   &
         ONLY:  particle_advection, particle_advection_start, wang_kernel
@@ -194,5 +199,5 @@
 
     USE statistics,                                                            &
-        ONLY:  flow_statistics_called, hom, pr_palm
+        ONLY:  flow_statistics_called, hom, pr_palm, sums_ls_l
 
     USE user_actions_mod,                                                      &
@@ -253,6 +258,7 @@
 !--    Determine ug, vg and w_subs in dependence on data from external file 
 !--    LSF_DATA
-       IF ( large_scale_forcing .AND. lsf_vert ) THEN
+       IF ( large_scale_forcing .AND. lsf_vert )  THEN
            CALL ls_forcing_vert ( simulated_time )
+           sums_ls_l = 0.0_wp
        ENDIF
 
@@ -283,7 +289,17 @@
 !--          buoyancy terms (WARNING: only the respective last call of
 !--          calc_mean_profile defines the reference state!)
-             IF ( .NOT. neutral )  CALL calc_mean_profile( pt, 4, 'time_int' )
-             IF ( ocean         )  CALL calc_mean_profile( rho, 64, 'time_int' )
-             IF ( humidity      )  CALL calc_mean_profile( vpt, 44, 'time_int' )
+             IF ( .NOT. neutral )  THEN
+                CALL calc_mean_profile( pt, 4 )
+                ref_state(:)  = hom(:,1,4,0) ! this is used in the buoyancy term
+             ENDIF
+             IF ( ocean )  THEN
+                CALL calc_mean_profile( rho, 64 )
+                ref_state(:)  = hom(:,1,64,0)
+             ENDIF
+             IF ( humidity )  THEN
+                CALL calc_mean_profile( vpt, 44 )
+                ref_state(:)  = hom(:,1,44,0)
+             ENDIF
+
           ENDIF
 
@@ -291,4 +307,14 @@
           IF ( ( ws_scheme_mom .OR. ws_scheme_sca )  .AND.  &
                intermediate_timestep_count == 1 )  CALL ws_statistics
+!
+!--       In case of nudging calculate current nudging time scale and horizontal
+!--       means of u,v,pt and q
+          IF ( nudging )  THEN
+             CALL calc_tnudge( simulated_time )
+             CALL calc_mean_profile( u, 1 )
+             CALL calc_mean_profile( v, 2 )
+             CALL calc_mean_profile( pt, 4 )
+             CALL calc_mean_profile( q, 41 )
+          ENDIF
 
 !
